/*
 * Note: this file originally auto-generated by mib2c using
 *       version : 12088 $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "h4aWlanPhyTable.h"


/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement h4aWlanPhyTable get routines.
 * TODO:240:M: Implement h4aWlanPhyTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table h4aWlanPhyTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * HAMNET-ALIX-MIB::h4aWlanPhyTable is subid 2 of h4aWlanPhy.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement h4aWlanPhyTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
h4aWlanPhyTable_indexes_set_tbl_idx(h4aWlanPhyTable_mib_index * tbl_idx,
                                    long h4aWlanPhyIndex_val)
{
    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyTable_indexes_set_tbl_idx", "called\n"));

    /*
     * h4aWlanPhyIndex(1)/INTEGER32/ASN_INTEGER/long(long)//l/A/w/e/r/d/h 
     */
    tbl_idx->h4aWlanPhyIndex = h4aWlanPhyIndex_val;


    return MFD_SUCCESS;
}                               /* h4aWlanPhyTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
h4aWlanPhyTable_indexes_set(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                            long h4aWlanPhyIndex_val)
{
    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyTable_indexes_set",
                "called\n"));

    if (MFD_SUCCESS !=
        h4aWlanPhyTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                            h4aWlanPhyIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != h4aWlanPhyTable_index_to_oid(&rowreq_ctx->oid_idx,
                                          &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* h4aWlanPhyTable_indexes_set */


/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanPhyEntry.h4aWlanPhyName
 * h4aWlanPhyName is subid 2 of h4aWlanPhyEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2.1.2
 * Description:
MAC Address.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 32a
 *
 * Ranges:  0 - 32;
 *
 * Its syntax is DisplayString32 (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 32)
 */
/**
 * Extract the current value of the h4aWlanPhyName data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanPhyName_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param h4aWlanPhyName_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by h4aWlanPhyName.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*h4aWlanPhyName_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update h4aWlanPhyName_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
h4aWlanPhyName_get(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                   char **h4aWlanPhyName_val_ptr_ptr,
                   size_t *h4aWlanPhyName_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != h4aWlanPhyName_val_ptr_ptr)
                   && (NULL != *h4aWlanPhyName_val_ptr_ptr));
    netsnmp_assert(NULL != h4aWlanPhyName_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyName_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanPhyName data.
     * copy (* h4aWlanPhyName_val_ptr_ptr ) data and (* h4aWlanPhyName_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for h4aWlanPhyName data
     */
    if ((NULL == (*h4aWlanPhyName_val_ptr_ptr)) ||
        ((*h4aWlanPhyName_val_ptr_len_ptr) <
         (rowreq_ctx->data.h4aWlanPhyName_len *
          sizeof(rowreq_ctx->data.h4aWlanPhyName[0])))) {
        /*
         * allocate space for h4aWlanPhyName data
         */
        (*h4aWlanPhyName_val_ptr_ptr) =
            malloc(rowreq_ctx->data.h4aWlanPhyName_len *
                   sizeof(rowreq_ctx->data.h4aWlanPhyName[0]));
        if (NULL == (*h4aWlanPhyName_val_ptr_ptr)) {
            snmp_log(LOG_ERR, "could not allocate memory\n");
            return MFD_ERROR;
        }
    }
    (*h4aWlanPhyName_val_ptr_len_ptr) =
        rowreq_ctx->data.h4aWlanPhyName_len *
        sizeof(rowreq_ctx->data.h4aWlanPhyName[0]);
    memcpy((*h4aWlanPhyName_val_ptr_ptr), rowreq_ctx->data.h4aWlanPhyName,
           rowreq_ctx->data.h4aWlanPhyName_len *
           sizeof(rowreq_ctx->data.h4aWlanPhyName[0]));

    return MFD_SUCCESS;
}                               /* h4aWlanPhyName_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanPhyEntry.h4aWlanPhyMac
 * h4aWlanPhyMac is subid 3 of h4aWlanPhyEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2.1.3
 * Description:
MAC Address.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 1x:
 *
 * Ranges:  6;
 *
 * Its syntax is MacAddress (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 6)
 */
/**
 * Extract the current value of the h4aWlanPhyMac data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanPhyMac_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param h4aWlanPhyMac_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by h4aWlanPhyMac.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*h4aWlanPhyMac_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update h4aWlanPhyMac_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
h4aWlanPhyMac_get(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                  char **h4aWlanPhyMac_val_ptr_ptr,
                  size_t *h4aWlanPhyMac_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != h4aWlanPhyMac_val_ptr_ptr)
                   && (NULL != *h4aWlanPhyMac_val_ptr_ptr));
    netsnmp_assert(NULL != h4aWlanPhyMac_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyMac_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanPhyMac data.
     * copy (* h4aWlanPhyMac_val_ptr_ptr ) data and (* h4aWlanPhyMac_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for h4aWlanPhyMac data
     */
    if ((NULL == (*h4aWlanPhyMac_val_ptr_ptr)) ||
        ((*h4aWlanPhyMac_val_ptr_len_ptr) <
         (rowreq_ctx->data.h4aWlanPhyMac_len *
          sizeof(rowreq_ctx->data.h4aWlanPhyMac[0])))) {
        /*
         * allocate space for h4aWlanPhyMac data
         */
        (*h4aWlanPhyMac_val_ptr_ptr) =
            malloc(rowreq_ctx->data.h4aWlanPhyMac_len *
                   sizeof(rowreq_ctx->data.h4aWlanPhyMac[0]));
        if (NULL == (*h4aWlanPhyMac_val_ptr_ptr)) {
            snmp_log(LOG_ERR, "could not allocate memory\n");
            return MFD_ERROR;
        }
    }
    (*h4aWlanPhyMac_val_ptr_len_ptr) =
        rowreq_ctx->data.h4aWlanPhyMac_len *
        sizeof(rowreq_ctx->data.h4aWlanPhyMac[0]);
    memcpy((*h4aWlanPhyMac_val_ptr_ptr), rowreq_ctx->data.h4aWlanPhyMac,
           rowreq_ctx->data.h4aWlanPhyMac_len *
           sizeof(rowreq_ctx->data.h4aWlanPhyMac[0]));

    return MFD_SUCCESS;
}                               /* h4aWlanPhyMac_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanPhyEntry.h4aWlanPhyNoisefloor
 * h4aWlanPhyNoisefloor is subid 4 of h4aWlanPhyEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2.1.4
 * Description:
Noise floor as reported by WLAN module.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: d
 *
 * Ranges:  -256 - 256;
 *
 * Its syntax is SignalLevel (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the h4aWlanPhyNoisefloor data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanPhyNoisefloor_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
h4aWlanPhyNoisefloor_get(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                         long *h4aWlanPhyNoisefloor_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != h4aWlanPhyNoisefloor_val_ptr);


    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyNoisefloor_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanPhyNoisefloor data.
     * copy (* h4aWlanPhyNoisefloor_val_ptr ) from rowreq_ctx->data
     */
    (*h4aWlanPhyNoisefloor_val_ptr) =
        rowreq_ctx->data.h4aWlanPhyNoisefloor;

    return MFD_SUCCESS;
}                               /* h4aWlanPhyNoisefloor_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanPhyEntry.h4aWlanPhyTxPower
 * h4aWlanPhyTxPower is subid 5 of h4aWlanPhyEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2.1.5
 * Description:
Noise floor as reported by WLAN module.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: d
 *
 * Ranges:  -256 - 256;
 *
 * Its syntax is SignalLevel (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the h4aWlanPhyTxPower data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanPhyTxPower_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
h4aWlanPhyTxPower_get(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                      long *h4aWlanPhyTxPower_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != h4aWlanPhyTxPower_val_ptr);


    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyTxPower_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanPhyTxPower data.
     * copy (* h4aWlanPhyTxPower_val_ptr ) from rowreq_ctx->data
     */
    (*h4aWlanPhyTxPower_val_ptr) = rowreq_ctx->data.h4aWlanPhyTxPower;

    return MFD_SUCCESS;
}                               /* h4aWlanPhyTxPower_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanPhyEntry.h4aWlanPhyBandwidth
 * h4aWlanPhyBandwidth is subid 6 of h4aWlanPhyEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.1.2.1.6
 * Description:
Channel bandwidth, 5/10/20 MHz.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is INTEGER32 (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the h4aWlanPhyBandwidth data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanPhyBandwidth_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
h4aWlanPhyBandwidth_get(h4aWlanPhyTable_rowreq_ctx * rowreq_ctx,
                        long *h4aWlanPhyBandwidth_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != h4aWlanPhyBandwidth_val_ptr);


    DEBUGMSGTL(("verbose:h4aWlanPhyTable:h4aWlanPhyBandwidth_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanPhyBandwidth data.
     * copy (* h4aWlanPhyBandwidth_val_ptr ) from rowreq_ctx->data
     */
    (*h4aWlanPhyBandwidth_val_ptr) = rowreq_ctx->data.h4aWlanPhyBandwidth;

    return MFD_SUCCESS;
}                               /* h4aWlanPhyBandwidth_get */



/** @} */
